<?php

/*
**
   +======================================================================+
   | SynApp2 - Web Application Generator                                  |
   +======================================================================+
**
** http://www.synapp2.org
**
*/

// add your application specific customization code here

function extra_employee_job()
{
    return "(select JOB from (select JOB_HISTORY.EMPLOYEE_ID EID, (select JOB_TITLE from JOBS where JOBS.JOB_ID = JOB_HISTORY.JOB_ID) JOB
                              from JOB_HISTORY
                              where JOB_HISTORY.EMPLOYEE_ID = EMPLOYEE_ID
                              order by START_DATE desc)
             where ROWNUM = 1 and EID = EMPLOYEES.EMPLOYEE_ID)";
}

function extra_employee_reports_to()
{
    return "(select REPORTS_TO from (select JOB_HISTORY.EMPLOYEE_ID EID, (select FIRST_NAME || ' ' || LAST_NAME from EMPLOYEES where EMPLOYEE_ID = JOB_HISTORY.REPORTS_TO_ID) REPORTS_TO
                                     from JOB_HISTORY
                                     where JOB_HISTORY.EMPLOYEE_ID = EMPLOYEE_ID
                                     order by START_DATE desc)
             where ROWNUM = 1 and EID = EMPLOYEES.EMPLOYEE_ID)";
}

function extra_employee_department()
{
    return "(select DEPARTMENT from (select JOB_HISTORY.EMPLOYEE_ID EID, (select DEPARTMENT_NAME from DEPARTMENTS where DEPARTMENTS.DEPARTMENT_ID = JOB_HISTORY.DEPARTMENT_ID) DEPARTMENT
                                     from JOB_HISTORY
                                     where JOB_HISTORY.EMPLOYEE_ID = EMPLOYEE_ID
                                     order by START_DATE desc)
             where ROWNUM = 1 and EID = EMPLOYEES.EMPLOYEE_ID)";
}

function extra_employee_direct_reports()
{
    return "(select count(m.EMPLOYEE_ID) from JOB_HISTORY jh, EMPLOYEES e, EMPLOYEES m
             where e.EMPLOYEE_ID = jh.EMPLOYEE_ID and
                   m.EMPLOYEE_ID = jh.REPORTS_TO_ID and
                   jh.REPORTS_TO_ID = EMPLOYEES.EMPLOYEE_ID and
                   jh.JOB_HISTORY_ID = (select JHID from (select JOB_HISTORY_ID JHID, EMPLOYEE_ID EID from JOB_HISTORY order by EMPLOYEE_ID, START_DATE desc)
                                        where ROWNUM = 1 and EID = jh.EMPLOYEE_ID)
             group by m.EMPLOYEE_ID)";
}

function extra_department_employee_count()
{
    return "(select count(d2.DEPARTMENT_ID) from JOB_HISTORY jh, EMPLOYEES e, DEPARTMENTS d2
             where e.EMPLOYEE_ID = jh.EMPLOYEE_ID and
                   d2.DEPARTMENT_ID = jh.DEPARTMENT_ID and
                   jh.DEPARTMENT_ID = DEPARTMENTS.DEPARTMENT_ID and
                   jh.JOB_HISTORY_ID = (select JHID from (select JOB_HISTORY_ID JHID, EMPLOYEE_ID EID from JOB_HISTORY order by EMPLOYEE_ID, START_DATE desc)
                                        where ROWNUM = 1 and EID = jh.EMPLOYEE_ID)
             group by d2.DEPARTMENT_ID)";
}

////

@include('oci_export.php');

$this->m_data[APPID]['HRV2'][INCL][NAV] = 'sql_export';
$this->m_data[APPID]['HRV2'][QID]['sql_export'][PROCESS][PROCESS_MAIN] = 'proc_export';

////

function proc_export(&$args, &$action, &$adhoc_markup)
{
    $dxo = new oci_export();

    $dxo->do_export();

    $adhoc_markup[] = "<br />" . (int)$dxo->save_as($args['filename']) . " bytes written";

    return true; // continue action
}

////

?>
